# GMOS minimalistic automatic reduction script for imaging - GG, march 2022

print "Step 1."
gbias @bias_list.txt outbias='bias_out.fits'  fl_over+  fl_trim+  logfile='gbias.log' order=63.

print "Step 2."
gireduce @twilight_list.txt outpref='f' fl_bias+ fl_over+ fl_trim+ bias='bias_out.fits' order=63. fl_qecorr- logfile='gireduce_twilight.log'

files fg//@twilight_list.txt > qe_list.txt

cl < qemeasure_adv_2022mar28.cl

gqecorr @qe_list.txt qecorr_data=./gmosQEfactors_mod_tw.dat logfile='gqecorr_flat.log'

giflat inflats='q//@qe_list.txt' outflat='Twilight.fits' fl_bias- fl_over- fl_trim- logfile='giflat.log'  fl_qecorr- 

print "Step 3."
gireduce @science_list.txt outpref='r' bias='bias_out.fits' fl_over+ fl_flat- order=63. logfile='gireduce_sci.log'

gqecorr rg//@science_list.txt logfile='gqecorr_sci.log'  

print "Step 4."
gireduce qrg//@science_list.txt fl_bias- flat1=Twilight.fits logfile='gireduce_sci.log'

print "Step 5."
imreplace rqrg*.fits[5] 0.
imreplace rqrg*.fits[3][225:236,*] 0.  
imreplace rqrg*.fits[8][93:96,*] 0.    
imreplace rqrg*.fits[8][134:143,*] 0.

print "Step 6."
ls rqrg*.fits > reduced.txt
string *list1
list1='reduced.txt'
while (fscan (list1, s1) != EOF){
	gemarith (s1,'*', 'frame2x2.fits', 'f'//s1)
	}

print "Step 7."
files frqrg*.fits > qe_list.txt
cl < qemeasure_adv_2022mar28.cl
gqecorr @qe_list.txt logfile='gqecorr_sci.log' qecorr_data=./gmosQEfactors_mod_tw.dat

gmosaic qfrqrg*.fits fl_fixpix- fl_clean-

print "Step 8."
gemcombine m*.fits  output='median.fits' combine='median' reject='avsigclip' lthreshold=3800. offsets='wcs' scale='median' bpmfile='bpm.fits'

print "Step 9."
crutil

imcopy median.fits[0] cmedian.fits[0]

crmedian median.fits[SCI,1] output='cmedian.fits[SCI,1]' crmask='bpm.fits' median=' '  sigma=' ' residual=' '  var0=0.  var1=0. var2=0. lsigma=100. hsigma=8. ncmed=5 nlmed=5 ncsig=15 nlsig=15

displ bpm_ext_1.fits[1] 1 

